package workplace.example;

import java.util.ArrayList;

import android.content.res.Resources;

public class CharacterSheet {
	int raceID;
	String raceName;
	int casteID;
	String casteName;

	String name;
	int age;

	ArrayList<Property> propertyList;
	//felszerelsek s a kpzettsgek alapbl kszen vannak (ksz objektumot le kne menteni, majd visszatlteni ha kell)
	ArrayList<Equipment> equipmentList;
	ArrayList<Qualification> qualificationList;

	public CharacterSheet(int raceID, int casteID, int[] abilities, Resources res) {
		raceName = res.getStringArray(R.array.race_names)[raceID];
		casteName = res.getStringArray(R.array.caste_names)[casteID];

		name = "";
		age = 0;

		propertyList = new ArrayList<Property>();
		equipmentList = new ArrayList<Equipment>();
		// Adatbzis hozzfrs is szksges itt!!

		String base = "Generlt alap";
		propertyList.add(new Property("Er", PropertyType.Er));
		getProperty(PropertyType.Er).AddModificatory(new SimpleProperty(base, abilities[0]));
		propertyList.add(new Property("Gyorsasg", PropertyType.Gyorsasg));
		getProperty(PropertyType.Gyorsasg).AddModificatory(new SimpleProperty(base, abilities[1]));
		propertyList.add(new Property("gyessg", PropertyType.gyessg));
		getProperty(PropertyType.gyessg).AddModificatory(new SimpleProperty(base, abilities[2]));
		propertyList.add(new Property("llkpessg", PropertyType.llkpessg));
		getProperty(PropertyType.llkpessg).AddModificatory(new SimpleProperty(base, abilities[3]));
		propertyList.add(new Property("Egszsg", PropertyType.Egszsg));
		getProperty(PropertyType.Egszsg).AddModificatory(new SimpleProperty(base, abilities[4]));
		propertyList.add(new Property("Szpsg", PropertyType.Szpsg));
		getProperty(PropertyType.Szpsg).AddModificatory(new SimpleProperty(base, abilities[5]));
		propertyList.add(new Property("Intelligencia", PropertyType.Intelligencia));
		getProperty(PropertyType.Intelligencia).AddModificatory(new SimpleProperty(base, abilities[6]));
		propertyList.add(new Property("Akarater", PropertyType.Akarater));
		getProperty(PropertyType.Akarater).AddModificatory(new SimpleProperty(base, abilities[7]));
		propertyList.add(new Property("Asztrl", PropertyType.Asztrl));
		getProperty(PropertyType.Asztrl).AddModificatory(new SimpleProperty(base, abilities[8]));

		propertyList.add(new Property("Kezdemnyez rtk", PropertyType.K));
		getProperty(PropertyType.K).AddModificatory(getProperty(PropertyType.Gyorsasg), new Above10());
		getProperty(PropertyType.K).AddModificatory(getProperty(PropertyType.gyessg), new Above10());

		propertyList.add(new Property("Tmad rtk", PropertyType.T));
		getProperty(PropertyType.T).AddModificatory(getProperty(PropertyType.Er), new Above10());
		getProperty(PropertyType.T).AddModificatory(getProperty(PropertyType.Gyorsasg), new Above10());
		getProperty(PropertyType.T).AddModificatory(getProperty(PropertyType.gyessg), new Above10());

		propertyList.add(new Property("Vdekez rtk", PropertyType.V));
		getProperty(PropertyType.V).AddModificatory(getProperty(PropertyType.Gyorsasg), new Above10());
		getProperty(PropertyType.V).AddModificatory(getProperty(PropertyType.gyessg), new Above10());

		propertyList.add(new Property("Clz rtk", PropertyType.C));
		getProperty(PropertyType.C).AddModificatory(getProperty(PropertyType.gyessg), new Above10());

		propertyList.add(new Property("Sebzs", PropertyType.Sp));
		getProperty(PropertyType.Sp).AddModificatory(getProperty(PropertyType.Er), new Calculation() {
			public int calculate(int value) {
				if (value <= 16) {
					return 0;
				} else {
					return (value - 16);
				}
			}
		});

		propertyList.add(new Property("Mozgsgtl tnyez", PropertyType.MGT));
		getProperty(PropertyType.Gyorsasg).AddModificatory(getProperty(PropertyType.MGT), new Calculation() {
			public int calculate(int value) {
				return (-value);
			}
		});
		getProperty(PropertyType.gyessg).AddModificatory(getProperty(PropertyType.MGT), new Calculation() {
			public int calculate(int value) {
				return (-value);
			}
		});

		propertyList.add(new Property("Sebzs felfog rtk", PropertyType.SF));
		// Pnclzat

		base = "Faj alap";
		int value = res.getIntArray(R.array.ability_ero)[raceID];
		if (value != 0)
			getProperty(PropertyType.Er).AddModificatory(new SimpleProperty(base, value));
		value = res.getIntArray(R.array.ability_gyorsasag)[raceID];
		if (value != 0)
			getProperty(PropertyType.Gyorsasg).AddModificatory(new SimpleProperty(base, value));
		value = res.getIntArray(R.array.ability_ugyesseg)[raceID];
		if (value != 0)
			getProperty(PropertyType.gyessg).AddModificatory(new SimpleProperty(base, value));
		value = res.getIntArray(R.array.ability_allokepesseg)[raceID];
		if (value != 0)
			getProperty(PropertyType.llkpessg).AddModificatory(new SimpleProperty(base, value));
		value = res.getIntArray(R.array.ability_egeszseg)[raceID];
		if (value != 0)
			getProperty(PropertyType.Egszsg).AddModificatory(new SimpleProperty(base, value));
		value = res.getIntArray(R.array.ability_szepseg)[raceID];
		if (value != 0)
			getProperty(PropertyType.Szpsg).AddModificatory(new SimpleProperty(base, value));
		value = res.getIntArray(R.array.ability_intelligencia)[raceID];
		if (value != 0)
			getProperty(PropertyType.Intelligencia).AddModificatory(new SimpleProperty(base, value));
		value = res.getIntArray(R.array.ability_akaratero)[raceID];
		if (value != 0)
			getProperty(PropertyType.Akarater).AddModificatory(new SimpleProperty(base, value));
		value = res.getIntArray(R.array.ability_asztral)[raceID];
		if (value != 0)
			getProperty(PropertyType.Asztrl).AddModificatory(new SimpleProperty(base, value));

		base = "Kaszt alap";
		value = res.getIntArray(R.array.caste_KE)[casteID];
		if (value != 0)
			getProperty(PropertyType.K).AddModificatory(new SimpleProperty(base, value));
		value = res.getIntArray(R.array.caste_TE)[casteID];
		if (value != 0)
			getProperty(PropertyType.T).AddModificatory(new SimpleProperty(base, value));
		value = res.getIntArray(R.array.caste_VE)[casteID];
		if (value != 0)
			getProperty(PropertyType.V).AddModificatory(new SimpleProperty(base, value));
		value = res.getIntArray(R.array.caste_CE)[casteID];
		if (value != 0)
			getProperty(PropertyType.C).AddModificatory(new SimpleProperty(base, value));

		Equipment e = new Equipment("Varzsital");
		e.AddPropertyModifier(PropertyType.Er, 2);
		e.AddPropertyModifier(PropertyType.Asztrl, -2);
		this.AddEquipment(e);
	}

	public Property getProperty(PropertyType type) {
		for (Property property : propertyList) {
			if (property.getPropertyType() == type) {
				return property;
			}
		}
		return null;
	}

	public String getRaceName() {
		return raceName;
	}

	public String getCasteName() {
		return casteName;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getName() {
		return name;
	}

	public void setAge(int age) {
		this.age = age;
	}

	public int getAge() {
		return age;
	}

	@Override
	public String toString() {
		return String.format("%s %d ves (%s, %s)", getName(), getAge(), getRaceName(), getCasteName());
	}

	public void AddEquipment(Equipment e) {
		equipmentList.add(e);
		Property[] properties = e.getProperties();
		for (Property property : properties) {
			getProperty(property.getPropertyType()).AddModificatory(property);
		}
	}

	public void Hurting(int damage, DamageType type) {
		// COMMENT: operating with "Heal" class
	}

	enum DamageType {
		Simple, OnlyPain, OnlyHeal
	}
}

enum PropertyType {
	Er, Gyorsasg, gyessg, llkpessg, Egszsg, Szpsg, Intelligencia, Akarater, Asztrl, K, T, V, C, SF, MGT, Sp
}

interface BaseProperty {
	int getValue();

	String getName();

	// void setOnRefreshListener();
}

class SimpleProperty implements BaseProperty {
	String name;
	int baseValue;

	public SimpleProperty(String name, int baseValue) {
		this.name = name;
		this.baseValue = baseValue;
	}

	public int getValue() {
		return baseValue;
	}

	public String getName() {
		return name;
	}
}

class Property implements BaseProperty {
	String name;
	PropertyType type;
	ArrayList<BaseProperty> propertyList;
	ArrayList<Calculation> calculationList;

	public Property(String name, PropertyType type) {
		this.name = name;
		this.type = type;
		this.propertyList = new ArrayList<BaseProperty>();
		this.calculationList = new ArrayList<Calculation>();
	}

	public int getValue() {
		int sum = 0;

		for (int i = 0; i < propertyList.size(); i++) {
			Calculation c = calculationList.get(i);
			int value = propertyList.get(i).getValue();
			if (c == null) {
				sum += value;
			} else {
				sum += c.calculate(value);
			}
		}

		return sum;
	}

	public PropertyType getPropertyType() {
		return type;
	}

	public void AddModificatory(BaseProperty p, Calculation c) {
		propertyList.add(p);
		calculationList.add(c);
	}

	public void AddModificatory(BaseProperty p) {
		AddModificatory(p, null);
	}

	public String getSubProperties() {
		String sum = "";
		for (int i = 0; i < propertyList.size(); i++) {
			Calculation c = calculationList.get(i);

			int value = propertyList.get(i).getValue();
			if (c != null) {
				value = c.calculate(value);
			}
			if (value != 0) {
				sum += propertyList.get(i).getName() + ": ";
				sum += String.valueOf(value);
				sum += "\n";
			}
		}
		return sum;
	}

	public String getName() {
		return name;
	}
}

class Qualification implements BaseProperty {
	String qualificationName;
	int qualificationID;

	public Qualification(int qualificationID) {

	}

	public int getValue() {
		// TODO Auto-generated method stub
		return 0;
	}

	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}
}

enum QualificationType {
	Percentage, Grade
}

interface Calculation {
	int calculate(int value);
}

class Above10 implements Calculation {

	public int calculate(int value) {
		if (value <= 10) {
			return 0;
		} else {
			return (value - 10);
		}
	}

}

interface OnRefreshListener {
	void OnRefresh();
}

class Equipment {
	String name;
	ArrayList<Property> propertyList;

	public Equipment(String name) {
		this.name = name;
		this.propertyList = new ArrayList<Property>();
	}

	public void AddPropertyModifier(PropertyType type, int value) {
		Property property = new Property(name, type);
		property.AddModificatory(new SimpleProperty(name, value));
		propertyList.add(property);
	}

	public Property[] getProperties() {
		return propertyList.toArray(new Property[0]);
	}
}